#include "monQP.h"

#include <iostream>
#include <itpp/itbase.h>
#include <itpp/itstat.h>
// monQP implementation...



using namespace std;
using namespace itpp;



double rcond(const mat &M)
{
    return norm(M,1)*norm(inv(M),1);
}

bvec issup(const mat &M,double val=0)
{
    bvec res(M.rows()*M.cols());

    for (int i=0;i<M.rows()*M.cols();i++)
        if (M(i)>val)
            res(i)=1;
        else
            res(i)=0;

    return res;

}

bvec issup(const ivec &M,double val=0)
{
    bvec res(M.length());

    for (int i=0;i<M.length();i++)
        if (M(i)>val)
            res(i)=1;
        else
            res(i)=0;

    return res;

}

bvec issup(const mat &M,const mat &M2)
{
    bvec res(M.rows()*M.cols());

    for (int i=0;i<M.rows()*M.cols();i++)
        if (M(i)>M2(i))
            res(i)=1;
        else
            res(i)=0;

    return res;

}

bvec isinf(const mat &M,double val=0)
{
    bvec res(M.rows()*M.cols());

    for (int i=0;i<M.rows()*M.cols();i++)
        if (M(i)<val)
            res(i)=1;
        else
            res(i)=0;

    return res;

}


// retourne 1 si une valeur de M est inferieur à val
int suminf(const mat &M,double val=0)
{
    int res=0;

    for (int i=0;i<M.rows()*M.cols();i++)
        if (M(i)<val)
            res=1;


    return res;

}

// retourne 1 si une valeur de M est superieur à val
int sumsup(const mat &M, double val=0)
{
    int res=0;

    for (int i=0;i<M.rows()*M.cols();i++)
        if (M(i)>val)
            res=1;


    return res;

}

// retourne 1 si une valeur de M est superieur à M2
int sumsup(const mat &M, const mat &M2)
{
    int res=0;

    for (int i=0;i<M.rows()*M.cols();i++)
        if (M(i)>M2(i))
            res=1;


    return res;

}

// retourne M(ind,:)
mat matfromindicedmat(const mat &M,const ivec &ind)
{
    //mat res(ind.length(),1);

    //for (int i=0 ; i<ind.length() ; i++)
    //res(i)=M(ind(i));

    return M.get_rows(ind);
}

// retourne M(ind,:)
void setmatvalues(mat &M,const ivec &ind,const mat &M2)
{

    for (int i=0 ; i<ind.length() ; i++)
        M(ind(i),0)=M2(i);

}

void setivecvalues(ivec &v,const ivec &ind,int val)
{

    for (int i=0 ; i<ind.length() ; i++)
        v(ind(i))=val;

}

void setivecvalues(ivec &v,const ivec &ind,const ivec val)
{

    for (int i=0 ; i<ind.length() ; i++)
        v(ind(i))=val(i);

}

// retourne M(ind,ind2)
mat matfromindicedmat2(const mat &M, ivec &ind,ivec &ind2)
{
    /*mat res(ind.length(),ind2.length());

    for (int i=0 ; i<ind.length() ; i++)
        for (int j=0;j<ind2.length();j++)

            res(i,j)=M(ind(i),ind2(j));

    return res;*/
    mat temp=M.get_rows(ind);;
    return temp.get_cols(ind2);
}

// retourne M(ind)
ivec ivecfromindicedvec(ivec &M, ivec &ind)
{
    ivec res(ind);
    //res.zeros();
    for (int i=0 ; i<ind.length() ; i++)
        res(i)=M(ind(i));

    return res;
}

ivec ivecfromindicedvec2(ivec &M, ivec &ind)
{
    ivec res(ind);
    //res.zeros();
    for (int i=0 ; i<ind.length() ; i++)
        res(i)=M(ind(i));

    return res;
}

//res=M avec M(ind)=val)
ivec ivecfromindicedvecval(ivec &M, ivec &ind,int val)
{
    ivec res(M);
    //res.zeros();
    for (int i=0 ; i<ind.length() ; i++)
        res(ind(i))=val;

    return res;
}

bvec isequal(const mat &M,const mat &M2)
{
    bvec res(M.rows()*M.cols());

    for (int i=0;i<M.rows()*M.cols();i++)
        if (M(i)==M2(i))
            res(i)=1;
        else
            res(i)=0;

    return res;

}

bvec isequal(const ivec &ind,const double val)
{
    bvec res(ind.length());

    for (int i=0;i<ind.length();i++)
        if (ind(i)==val)
            res(i)=1;
        else
            res(i)=0;

    return res;

}

// returns a vector caontaining the differences between 2 matrixes
bvec isdiff(const mat &M,const mat &M2)
{
    bvec res(M.rows()*M.cols());

    for (int i=0;i<M.rows()*M.cols();i++)
        if (M(i)!=M2(i))
            res(i)=1;
        else
            res(i)=0;

    return res;

}

// binary and
bvec andbvec(bvec v1,bvec v2)
{
    bvec res(v1.size());

    for (int i=0;i<v1.size();i++)
        if (v1(i)!=0 && v2(i)!=0 )
            res(i)=1;
        else
            res(i)=0;

    return res;

}

ivec getintsuite(int n)
{
    ivec res(n);
    for (int i=0;i<n;i++)
        res(i)=i;

    return res;
}

void delvalues(ivec &ind, const ivec &indsup)
{
    int taille=indsup.length();
    ivec temp=indsup;
//sort(indsup);
    if (temp.length()>1) sort(temp);
    for (int i=indsup.length()-1;i>=0 ;i--)
    {

        ind.del(temp(i));
    }

}//

void delvalues(mat &ind, const ivec &indsup)
{
    int taille=indsup.length();
    ivec temp=indsup;

    if (temp.length()>1) sort(temp);
    for (int i=indsup.length()-1;i>=0 ;i--)
    {
        ind.del_row(temp(i));
    }

}

double Jcout(const mat &H,const mat &x,const mat &y,const mat &C,const ivec &ind,const mat &c)
{
    double res;

    mat X=zeros(H.rows(),1);

    bvec findok=issup(ind);
    bvec findB=isequal(ind,-1);

    ivec posok=find(findok);
    ivec posB=find(findB);


    setmatvalues(X,posok,x);
    setmatvalues(X,posB,matfromindicedmat(C,posB));

    //PRD(X.T()*H*X);
    //PRD(c.T()*X);



    mat temp=0.5*X.T()*H*X-c.T()*X;

    res=temp(0);


    return res;
}

mat getmatfromivec( ivec &ind)
{
    mat res(ind.length(),1);

    for (int i=0 ; i<ind.length() ; i++)
        res(i)=ind(i);

    return res;
}

mat addeye(const mat &M,double val)
{
    mat res(M);
    for (int i=0;i<M.rows();i++)
        res(i,i)=M(i,i)+val;
    return res;
}

void roundzero(mat &M, double minval)
{
    for (int i=0; i< M.rows() ;i++)
        for (int j=0; j< M.cols();j++)
            if (abs(M(i,j))<minval) M(i,j)=0;

}

double roundzero(double val, double minval)
{
    if (abs(val)<minval) return 0;
    else return val;

}

/*

% min 1/2  x' H x - c' x
%  x
% contrainte   A' x = b
%
% et         0 <= x_i  <= C_i
%


*/

void mon_QP(const mat &H2,const mat &c,const mat &A,const mat &b,const mat &C2,const mat &xinit,mat &xnew,mat &lambda,mat &pos,mat &mu,double l,int verbose)
{

    // Initialisation

    double minval=1.4901e-08;
    int xinitempty=0;

    if (xinit.rows()==0)
        xinitempty=1;

    //H = oeuil+ H; // preconditionning
    mat H=addeye(H2,l);
    mat C;

    // Calcul des tailles
    int n=H.rows();
    int nd=H.cols();
    int nl=c.rows();
    int nc=c.cols();
    int nlc=A.rows();
    int ncc=A.cols();
    int nlb=b.rows();
    int ncb=b.cols();



    mat x,auxH,M,d,auxM;
    ivec indsuptot, indsup, ind;
    int nsup;



    //vérification des dimensions

    if (nd!= n)
        cout<<"H must be a square matrix n by n"<<endl;

    if (nl!= n)
        cout<<"H and c must have the same number of row"<<endl;


    if (nlc!= n)
        cout<<"H and A must have the same number of row"<<endl;

    if (nc != 1)
        cout<<"c must be a row vector"<<endl;

    if (ncb != 1)
        cout<<"b must be a row vector"<<endl;

    if (ncc != nlb)
        cout<<"A' and b  must have the same number of row"<<endl;

    if (C2.rows()!=nl) C=ones(nl,1)*C2;
    else C=C2;





    PRD(H);
    PRD(c);
    PRD(A);
    PRD(b);
    PRD(C);



    xnew = -1*ones(C.rows(),1);
    int ness = 0;
    ind="0 ";

    // initialisation des x

    if (xinitempty)
    {

        // à compléter avec une initialisation correcte

        x = C(0)/2*ones(ind.size(),1);
        lambda=ones(ncc,1);



    }
    else
    {

        bvec find1=isequal(xinit,C);
        bvec find2=andbvec(issup(xinit,0),isdiff(xinit,C));
        //(issup(xinit,0) && xinit !=C);

        indsuptot=find(find1);
        indsup=indsuptot;
        ind=find(find2);
        x = matfromindicedmat(xinit,ind);
        lambda=ones(ncc,1);



    }

    PRD(x);
    PRD(nsup);
    PRD(lambda);
    PRD(ind);

    // cleared!!!


    //Modification for QP without equality constraints
    //if (sum(A==0))
    //ncc=0;

    //Test definite positiveness of H
    mat U(H);
    bool testchol= chol(H,U);
    int firstchol=1;

    PRD(U);
    PRD(testchol);
    PRD(H);


    // Main loop!!!

    double Jold = 1000000000;

    //TODO penser


    if (verbose)    printf("      Cost     Delta Cost  #support  #up saturate\n" );
    int nbiter=0;
    int STOP = 0;
    int nbitermax=20*n;

    double tI,tS,t,mm,mmS,J;

    int indmin,indS,rien,mpos,mposS,nbverbose=0;

    mat ce,be,Cmat,Ae,At, temp, tempS,xt;
    bvec findad,findsup;
    ivec indad,indsat,poste,indout,indd(n),ivectmp;

    while (STOP !=1)
    {
        nbiter+=1;
        //PRD(nbiter);

        //ivec indd(n);
        indd.zeros();

        //if (nbiter>1) roundzero(x,minval);


        setivecvalues(indd,ind,ind+1);
        nsup=ind.length();
        setivecvalues(indd,indsuptot,-1);
        PRD(indd);
        PRD(ind);
        PRD(indsuptot);
        PRD(x);

        if (verbose)
        {
            J=Jcout(H,x,b,C,indd,c);
            if (nbverbose==20)
            {
                cout<<"      Cost     Delta Cost  #support  #up saturate\n" ;
                nbverbose=0;
            }

            nbverbose+=1;

            if (Jold==0)
            {
                printf("| %11.4e | %8.4f | %6.0f | %6.0f |\n",J,Jold-J,(double)nsup, (double)indsuptot.length());

            }
            else
            {
                if (Jold>J)
                    printf("| %11.4e | %8.4f | %6.0f | %6.0f |\n",J,min((Jold-J)/abs(Jold),99.9999),(double)nsup, (double)indsuptot.length());
                else
                    printf("| %11.4e | %8.4f | %6.0f | %6.0f |bad mouve\n",roundzero(J,minval),roundzero(max((Jold-J)/abs(Jold),-99.9999),minval),(double)nsup, (double)indsuptot.length());

            }

            Jold=J;
        }


        ce = matfromindicedmat(c,ind);
        be = b;



        if (indsuptot.length()>0) // if not empty
        {
            Cmat= ones(ind.length(),1)*(matfromindicedmat(C,indsuptot).T());
            PRD(Cmat);
            ce= ce - (mat)sum( elem_mult(Cmat,matfromindicedmat2(H,ind,indsuptot)),2);
            PRD(ce);
            Cmat= matfromindicedmat(C,indsuptot)*ones(1,A.cols());
            PRD(Cmat);
            be= be - (mat)sum( elem_mult(Cmat,matfromindicedmat(A,indsuptot)),1);
            PRD(be);
        }

        PRD(ce);
        PRD(be);

        Ae= matfromindicedmat(A,ind);
        PRD(Ae);
        At=Ae.T();
        //PRD(At);

        if (testchol!=0)
        {

            // définie positive
            auxH=matfromindicedmat2(H,ind,ind);

            testchol= chol(auxH,U);

            M= At*(backslash(U,backslash(U.T(),Ae)));
            d= backslash(U,backslash(U.T(),ce));

            d=At*d-be;
            PRD(d);

            //à discuter avec Canu il y avait un if

            M=M+l*eye(M.size());

            lambda=backslash(M,d);

            xnew=backslash(auxH,ce-Ae*lambda);

            PRD(xnew);
            PRD(lambda);


        }
        else
        {

            // non définie positive
            auxH=matfromindicedmat2(H,ind,ind);

            auxM=At*(backslash(auxH,Ae));

            M=auxM.T()*auxM;

            d=backslash(auxH,ce);

            d=At*d-be;

            M=M+l*eye(M.size());

            lambda=backslash(M,d);

            xnew=backslash(auxH,ce-Ae*lambda);

            PRD(xnew);
            PRD(lambda);


        }
        //roundzero(xnew,minval);
        PRD(xnew);


//        mexPrintf(" Jusque là tout va bien... \n");


        // on ataque le gran if!!!

        if ( (suminf(xnew,0) || sumsup(xnew,matfromindicedmat(C,ind))) && ind.length()>ncc)
        {
//            mexPrintf(" if oui \n");
            d = (xnew - x)+l;

            PRD(d);

            //PRD(suminf(xnew,0));
            //PRD(sumsup(xnew,matfromindicedmat(C,ind)));

            findad=isinf(xnew,0);
            findsup=issup(xnew,matfromindicedmat(C,ind));

            indad=find(findad);
            indsup=find(findsup);
            PRD(indsup);
            PRD(indad);

            if (indad.length()>0) temp= -elem_div(matfromindicedmat(C,indad),matfromindicedmat(d,indad));
            else temp.set_size(0,0,false);
            if (indsup.length()>0) tempS= elem_div(matfromindicedmat(C,ivecfromindicedvec(ind,indsup))-matfromindicedmat(x,indsup),matfromindicedmat(d,indsup));
            else tempS.set_size(0,0,false);
            PRD(temp);
            PRD(tempS);
            //PRD(matfromindicedmat(C,ivecfromindicedvec(ind,indsup)));
            //PRD(ivecfromindicedvec(ind,indsup));
            //PRD(matfromindicedmat(x,indsup));
            //PRD(matfromindicedmat(d,indsup));



            if (temp.rows()>0) tI=min(min(temp));
            if (tempS.rows()>0) tS=min(min(tempS));

            if (temp.rows()>0) min_index(temp,indmin,rien);
            if (tempS.rows()>0) min_index(tempS,indS,rien);

            if (temp.rows()==0) tI=tS+1;
            if (tempS.rows()==0) tS=tI+1;

            t=MIN(tI,tS);

            PRD(tI);
            PRD(tS);
            PRD(indmin);
            PRD(indS);


            x = x + t*d;

            PRD(x);

            if (tI<tS)
            {
                ind.del(indad(indmin));
                x.del_row(indad(indmin));

            }
            else
            {
                indsuptot.ins(indsuptot.length(),ind(indsup(indS)));
                ind.del(indsup(indS));
                x.del_row(indsup(indS));

            }
            PRD(x);

//            mexPrintf(" GIF oui" );





        }
        else
        {
//           mexPrintf(" ifnon \n");

            PRD(ind);
            PRD(indsuptot);
            xt=zeros(n,1);
            setmatvalues(xt,ind,xnew);
            PRD(xt);
            setmatvalues(xt,indsuptot,matfromindicedmat(C,indsuptot));
            PRD(xt);

            mu = H*xt - c + A*lambda;
            //roundzero(mu,minval);

            PRD(mu);

            indsat=getintsuite(n);

            PRD(indsat);

            ivectmp=concat(ind,indsuptot);

            delvalues(indsat,ivectmp);

            PRD(indsat);

            temp= matfromindicedmat(mu,indsat);
            PRD(temp);
            tempS= matfromindicedmat(-mu,indsuptot);
            PRD(tempS);



            if (indsat.length()>0) mm=min(min(temp));
            if (indsuptot.length()>0) mmS=min(min(tempS));

            if (indsat.length()>0) min_index(temp,mpos,rien);
            if (indsuptot.length()>0) min_index(tempS,mposS,rien);


            if (temp.rows()==0) mm=mmS+1;
            if (tempS.rows()==0) mmS=mm+1;

            PRD(mm);
            PRD(mmS);
            PRD(mpos);
            PRD(mposS);

            // Sort<int> sort;

//            mexPrintf(" GIF non" );


            if (((mm<-minval&& indsat.length()>0) || (mmS <  -minval&&(indsuptot.length()>0)) ) && nbiter<nbitermax)
            {
                if (indsuptot.length()==0 || mm < mmS)
                {
                    ind=concat(ind,indsat(mpos));
                    PRD(ind);
                    //sort.sort(0,ind.length()-1,ind);
                    sort(ind);
                    PRD(ind);
                    x=matfromindicedmat(xt,ind);
                    PRD(x);

                }
                else
                {
                    ind = concat(ind,indsuptot(mposS));
                    //sort.sort(0,ind.length()-1,ind);
                    sort(ind);
                    PRD(ind);
                    x=matfromindicedmat(xt,ind);
                    PRD(x);

                    indsuptot.del(mposS);



                }


            }
            else
            {

                STOP=1;
                poste=concat(ind,indsuptot);
                //                sort.sort(0,poste.length()-1,poste);

                PRD(poste)
                sort(poste);
                PRD(poste)
                pos= getmatfromivec(poste);
                xt = zeros(n,1);
                setmatvalues(xt,ind,xnew);
                setmatvalues(xt,indsuptot,matfromindicedmat(C,indsuptot));
                PRD(xt);

                indout=getintsuite(n);;
                delvalues(indout,poste);
                PRD(indout);

                xnew=xt;
                delvalues(xnew,indout);
                PRD(xnew);

            }




        }
        //PRD(ind);
        //PRD(indsuptot);

    }







}
