#include <iostream>
#include "mex.h"
#include <itpp/itmex.h>
#include "monQP.cpp"

void mon_QP2(const mat &H2,const mat &c,const mat &A,const mat &b,const mat &C2,const mat &xinit,mat &xnew,mat &lambda,mat &pos,mat &mu,double l,int verbose)
{

    // Initialisation

    double minval=1.4901e-08;
    int xinitempty=0;

    if (xinit.rows()==0)
        xinitempty=1;

    //H = oeuil+ H; // preconditionning
    mat H=addeye(H2,l);
    mat C;

    // Calcul des tailles
    int n=H.rows();
    int nd=H.cols();
    int nl=c.rows();
    int nc=c.cols();
    int nlc=A.rows();
    int ncc=A.cols();
    int nlb=b.rows();
    int ncb=b.cols();



    mat x,auxH,M,d,auxM;
    ivec indsuptot, indsup, ind;
    int nsup;



    //vérification des dimensions

    if (nd!= n)
        mexPrintf("H must be a square matrix n by n\n");

    if (nl!= n)
        mexPrintf("H and c must have the same number of row\n");


    if (nlc!= n)
        mexPrintf("H and A must have the same number of row\n");

    if (nc != 1)
        mexPrintf("c must be a row vector\n");

    if (ncb != 1)
        mexPrintf("b must be a row vector\n");

    if (ncc != nlb)
        mexPrintf("A' and b  must have the same number of row\n");

    if (C2.rows()!=nl) C=ones(nl,1)*C2;
    else C=C2;





    PRD(H);
    PRD(c);
    PRD(A);
    PRD(b);
    PRD(C);



    xnew = -1*ones(C.rows(),1);
    int ness = 0;
    ind="0 ";

    // initialisation des x

    if (xinitempty)
    {

        // à compléter avec une initialisation correcte

        x = C(0)/2*ones(ind.size(),1);
        lambda=ones(ncc,1);



    }
    else
    {

        bvec find1=isequal(xinit,C);
        bvec find2=andbvec(issup(xinit,0),isdiff(xinit,C));
        //(issup(xinit,0) && xinit !=C);

        indsuptot=find(find1);
        indsup=indsuptot;
        ind=find(find2);
        x = matfromindicedmat(xinit,ind);
        lambda=ones(ncc,1);



    }

    PRD(x);
    PRD(nsup);
    PRD(lambda);
    PRD(ind);

    // cleared!!!


    //Modification for QP without equality constraints
    //if (sum(A==0))
    //ncc=0;

    //Test definite positiveness of H
    mat U(H);
    bool testchol= chol(H,U);
    int firstchol=1;

    PRD(U);
    PRD(testchol);
    PRD(H);


    // Main loop!!!

    double Jold = 1000000000;


    if (verbose)    mexPrintf("      Cost     Delta Cost  #support  #up saturate\n" );
    int nbiter=0;
    int STOP = 0;
    int nbitermax=20*n;

    double tI,tS,t,mm,mmS,J;
    int indmin,indS,rien,mpos,mposS,nbverbose=0;

    mat ce,be,Cmat,Ae,At, temp, tempS,xt;
    bvec findad,findsup;
    ivec indad,indsat,poste,indout,indd(n),ivectmp;

    while (STOP !=1)
    {
        nbiter+=1;
        //PRD(nbiter);

        //ivec indd(n);
        indd.zeros();

        if (nbiter>1) roundzero(x,minval);


        setivecvalues(indd,ind,ind+1);
        nsup=ind.length();
        setivecvalues(indd,indsuptot,-1);
        PRD(indd);
        PRD(ind);
        PRD(indsuptot);
        PRD(x);

        if (verbose)
        {
            J=Jcout(H,x,b,C,indd,c);
            if (nbverbose==20)
            {
            mexPrintf("      Cost     Delta Cost  #support  #up saturate\n") ;
            nbverbose=0;
            }

            nbverbose+=1;

            if (Jold==0)
            {
                mexPrintf("| %11.4e | %8.4f | %6.0f | %6.0f |\n",J,Jold-J,(double)nsup, (double)indsuptot.length());

            }
            else
            {
            if (Jold>J)
                mexPrintf("| %11.4e | %8.4f | %6.0f | %6.0f |\n",J,min((Jold-J)/abs(Jold),99.9999),(double)nsup, (double)indsuptot.length());
            else
                mexPrintf("| %11.4e | %8.4f | %6.0f | %6.0f |bad mouve\n",roundzero(J,minval),roundzero(max((Jold-J)/abs(Jold),-99.9999),minval),(double)nsup, (double)indsuptot.length());

            }

            Jold=J;
        }


        ce = matfromindicedmat(c,ind);
        be = b;



        if (indsuptot.length()>0) // if not empty
        {
            Cmat= ones(ind.length(),1)*(matfromindicedmat(C,indsuptot).T());
            PRD(Cmat);
            ce= ce - (mat)sum( elem_mult(Cmat,matfromindicedmat2(H,ind,indsuptot)),2);
            PRD(ce);
            Cmat= matfromindicedmat(C,indsuptot)*ones(1,A.cols());
            PRD(Cmat);
            be= be - (mat)sum( elem_mult(Cmat,matfromindicedmat(A,indsuptot)),1);
            PRD(be);



        }

        PRD(ce);
        PRD(be);

        Ae= matfromindicedmat(A,ind);
        PRD(Ae);
        At=Ae.T();
        //PRD(At);

        if (testchol!=0)
        {

            // définie positive
            auxH=matfromindicedmat2(H,ind,ind);

            testchol= chol(auxH,U);

            M= At*(backslash(U,backslash(U.T(),Ae)));
            d= backslash(U,backslash(U.T(),ce));

            d=At*d-be;
            PRD(d);

            //à discuter avec Canu il y avait un if

            M=M+l*eye(M.size());

            lambda=backslash(M,d);

            xnew=backslash(auxH,ce-Ae*lambda);

            PRD(xnew);
            PRD(lambda);


        }
        else
        {

            // non définie positive
            auxH=matfromindicedmat2(H,ind,ind);

            auxM=At*(backslash(auxH,Ae));

            M=auxM.T()*auxM;

            d=backslash(auxH,ce);

            d=At*d-be;

            M=M+l*eye(M.size());

            lambda=backslash(M,d);

            xnew=backslash(auxH,ce-Ae*lambda);

            PRD(xnew);
            PRD(lambda);


        }
        roundzero(xnew,minval);
        PRD(xnew);


//        mexPrintf(" Jusque là tout va bien... \n");


        // on ataque le gran if!!!

        if ( (suminf(xnew,0) || sumsup(xnew,matfromindicedmat(C,ind))) && ind.length()>ncc)
        {
//            mexPrintf(" if oui \n");
            d = (xnew - x)+l;

            PRD(d);

            //PRD(suminf(xnew,0));
            //PRD(sumsup(xnew,matfromindicedmat(C,ind)));

            findad=isinf(xnew,0);
            findsup=issup(xnew,matfromindicedmat(C,ind));

            indad=find(findad);
            indsup=find(findsup);
            PRD(indsup);
            PRD(indad);

            if (indad.length()>0) temp= -elem_div(matfromindicedmat(C,indad),matfromindicedmat(d,indad)); else temp.set_size(0,0,false);
            if (indsup.length()>0) tempS= elem_div(matfromindicedmat(C,ivecfromindicedvec(ind,indsup))-matfromindicedmat(x,indsup),matfromindicedmat(d,indsup)); else tempS.set_size(0,0,false);
            PRD(temp);
            PRD(tempS);
            //PRD(matfromindicedmat(C,ivecfromindicedvec(ind,indsup)));
            //PRD(ivecfromindicedvec(ind,indsup));
            //PRD(matfromindicedmat(x,indsup));
            //PRD(matfromindicedmat(d,indsup));



            if (temp.rows()>0) tI=min(min(temp));
            if (tempS.rows()>0) tS=min(min(tempS));

            if (temp.rows()>0) min_index(temp,indmin,rien);
            if (tempS.rows()>0) min_index(tempS,indS,rien);

            if (temp.rows()==0) tI=tS+1;
            if (tempS.rows()==0) tS=tI+1;

            t=MIN(tI,tS);

            PRD(tI);
            PRD(tS);
            PRD(indmin);
            PRD(indS);


            x = x + t*d;

            PRD(x);

            if (tI<tS)
            {
                ind.del(indad(indmin));
                x.del_row(indad(indmin));

            }
            else
            {
                indsuptot.ins(indsuptot.length(),ind(indsup(indS)));
                ind.del(indsup(indS));
                x.del_row(indsup(indS));

            }
            PRD(x);

//            mexPrintf(" GIF oui" );





        }
        else
        {
 //           mexPrintf(" ifnon \n");

            PRD(ind);
            PRD(indsuptot);
            xt=zeros(n,1);
            setmatvalues(xt,ind,xnew);
            PRD(xt);
            setmatvalues(xt,indsuptot,matfromindicedmat(C,indsuptot));
            PRD(xt);

            mu = H*xt - c + A*lambda;
            roundzero(mu,minval);

            PRD(mu);

            indsat=getintsuite(n);

            PRD(indsat);

            ivectmp=concat(ind,indsuptot);

            delvalues(indsat,ivectmp);

            PRD(indsat);

            temp= matfromindicedmat(mu,indsat);
            PRD(temp);
            tempS= matfromindicedmat(-mu,indsuptot);
            PRD(tempS);



            if (indsat.length()>0) mm=min(min(temp));
            if (indsuptot.length()>0) mmS=min(min(tempS));

            if (indsat.length()>0) min_index(temp,mpos,rien);
            if (indsuptot.length()>0) min_index(tempS,mposS,rien);


            if (temp.rows()==0) mm=mmS+1;
            if (tempS.rows()==0) mmS=mm+1;

            PRD(mm);
            PRD(mmS);
            PRD(mpos);
            PRD(mposS);

           // Sort<int> sort;

//            mexPrintf(" GIF non" );


            if (((mm<-minval&& indsat.length()>0) || (mmS <  -minval&&(indsuptot.length()>0)) ) && nbiter<nbitermax)
            {
                if (indsuptot.length()==0 || mm < mmS)
                {
                    ind=concat(ind,indsat(mpos));
                    PRD(ind);
                    //sort.sort(0,ind.length()-1,ind);
                    sort(ind);PRD(ind);
                    x=matfromindicedmat(xt,ind);
                    PRD(x);

                }
                else
                {
                    ind = concat(ind,indsuptot(mposS));
                    //sort.sort(0,ind.length()-1,ind);
                    sort(ind);
                    PRD(ind);
                    x=matfromindicedmat(xt,ind);
                    PRD(x);

                    indsuptot.del(mposS);



                }


            }
            else
            {

                STOP=1;
                poste=concat(ind,indsuptot);
                //                sort.sort(0,poste.length()-1,poste);
                sort(poste);
                pos= getmatfromivec(poste);
                xt = zeros(n,1);
                setmatvalues(xt,ind,xnew);
                setmatvalues(xt,indsuptot,matfromindicedmat(C,indsuptot));

                indout=getintsuite(n);;
                delvalues(indout,poste);

                xnew=xt;
                delvalues(xnew,indout);

            }




        }
        //PRD(ind);
        //PRD(indsuptot);

    }







}


void mexFunction(int n_output, mxArray *output[], int n_input, const mxArray *input[])
{
    // Check the number of inputs and output arguments
    if (n_output>4) mexErrMsgTxt("Wrong number of output variables!");
    if (n_input<5) mexErrMsgTxt("Not Enough input variables!");

    // Convert inputs... See matlab File

    mat H =mxArray2mat(input[0]);
    mat c =mxArray2mat(input[1]);
    mat A =mxArray2mat(input[2]);
    mat b =mxArray2mat(input[3]);
    mat C =mxArray2mat(input[4]);
    mat xinit,xnew, lambda, pos, mu;
    int xinitempty=1;

    double l=0;
    double minval=1.4901e-08;
    int verbose=0;

    // on adpate en fonction du nombre de paramètres

    if (n_input>5)
        l=mxArray2double(input[5]);

    if (n_input>6)
        verbose=mxArray2int(input[6]);

    if (n_input>9)
    {
        xinit=mxArray2mat(input[9]);
        xinitempty=0;
    };

    //mexPrintf("Calling monqpcpp!!\n") ;



    //appel à la fonction c++



    //xnew=c;
    //lambda=c;
    //pos=c;
    //mu=c;
    mon_QP(H,c,A,b,C,xinit,xnew,lambda,pos,mu,l,verbose);

    pos=pos+1;






    output[0] = mxCreateDoubleMatrix(1,xnew.size(), mxREAL);
    output[1] = mxCreateDoubleMatrix(1,lambda.size(), mxREAL);
    output[2] = mxCreateDoubleMatrix(1,pos.size(), mxREAL);
    output[3] = mxCreateDoubleMatrix(1,mu.size(), mxREAL);

    mat2mxArray(xnew, output[0]);
    mat2mxArray(lambda, output[1]);
    mat2mxArray(pos, output[2]);
    mat2mxArray(mu, output[3]);

}


